// Generated by CoffeeScript 1.6.3
var ApiMock, CorsSupport, SslSupport, express, fs, protagonist, walker;

fs = require('fs');

protagonist = require('protagonist');

express = require('express');

walker = require('./walker');

SslSupport = require('./ssl-support');

CorsSupport = require('./cors-support');

ApiMock = (function() {
  function ApiMock(config) {
    var corsSupport, sslSupport;
    if (config['protagonist']) {
      protagonist = config['protagonist'];
    }
    if (config['express']) {
      express = config['express'];
    }
    if (config['blueprintPath']) {
      this.blueprintPath = config['blueprintPath'];
    }
    if (this.blueprintPath == null) {
      throw new Error("No blueprint path provided.");
    }
    this.configuration = config;
    this.app = express();
    if (this.configuration.options['ssl-enable']) {
      sslSupport = new SslSupport(this.app, {
        port: this.configuration.options['ssl-port'],
        host: this.configuration.options['ssl-host'],
        cert: this.configuration.options['ssl-cert'],
        key: this.configuration.options['ssl-key']
      });
    }
    if (!this.configuration.options['cors-disable']) {
      corsSupport = new CorsSupport(this.app);
    }
  }

  ApiMock.prototype.run = function() {
    var app, ast_json, data, e,
      _this = this;
    app = this.app;
    try {
      data = fs.readFileSync(this.blueprintPath, 'utf8');
    } catch (_error) {
      e = _error;
      throw e;
    }
    ast_json = "";
    return protagonist.parse(data, function(error, result) {
      var _ref, _ref1;
      if (error != null) {
        throw error;
      }
      ast_json = result.ast;
      try {
        walker(app, ast_json['resourceGroups']);
      } catch (_error) {
        error = _error;
        throw error;
      }
      return app.listen(((_ref = _this.configuration) != null ? (_ref1 = _ref.options) != null ? _ref1.port : void 0 : void 0) != null ? _this.configuration.options.port : 3000);
    });
  };

  return ApiMock;

})();

module.exports = ApiMock;
