// Generated by CoffeeScript 1.6.3
var expandUriTemplateWithParameters, ut;

ut = require('uri-template');

expandUriTemplateWithParameters = function(uriTemplate, parameters) {
  var ambigous, e, expression, param, parameter, parsed, result, text, toExpand, uriParameter, uriParameters, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2;
  result = {
    errors: [],
    warnings: [],
    uri: null
  };
  try {
    parsed = ut.parse(uriTemplate);
  } catch (_error) {
    e = _error;
    text = 'Failed to parse URI template';
    result['errors'].push(text);
    return result;
  }
  uriParameters = [];
  _ref = parsed['expressions'];
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    expression = _ref[_i];
    _ref1 = expression['params'];
    for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
      param = _ref1[_j];
      uriParameters.push(param['name']);
    }
  }
  _ref2 = Object.keys(parameters);
  for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
    parameter = _ref2[_k];
    if (uriParameters.indexOf(parameter) === -1) {
      text = "URI template doesn\'t contain expression for parameter" + " '" + parameter + "'";
      result['warnings'].push(text);
    }
  }
  if (parsed['expressions'].length === 0) {
    result['uri'] = uriTemplate;
  } else {
    ambigous = false;
    for (_l = 0, _len3 = uriParameters.length; _l < _len3; _l++) {
      uriParameter = uriParameters[_l];
      if (Object.keys(parameters).indexOf(uriParameter) === -1) {
        ambigous = true;
        text = "Ambigous URI template. " + "Parameter not defined:" + "'" + uriParameter + "'";
        result['warnings'].push(text);
      }
    }
    if (ambigous === false) {
      toExpand = {};
      for (_m = 0, _len4 = uriParameters.length; _m < _len4; _m++) {
        uriParameter = uriParameters[_m];
        param = parameters[uriParameter];
        if (param['required'] === true) {
          if (param['example'] === void 0) {
            ambigous = true;
            text = "Ambigous URI template. " + "No example value for parameter:" + "'" + uriParameter + "'";
            result['warnings'].push(text);
          } else {
            toExpand[uriParameter] = param['example'];
          }
        } else {
          if (param['example'] !== void 0) {
            toExpand[uriParameter] = param['example'];
          } else if (param['default'] !== void 0) {
            toExpand[uriParameter] = param['default'];
          }
        }
      }
    }
    if (ambigous === false) {
      result['uri'] = parsed.expand(toExpand);
    }
  }
  return result;
};

module.exports = expandUriTemplateWithParameters;
